--------------------------------------------------------------------------------
-- Company: 
-- Engineer:		Joerg Wolfram
--
-- Create Date:    	17.02.2007
-- Design Name:    
-- Module Name:    
-- Project Name: 	fbas_enc	
-- Target Device:  	XC9536 
-- Tool versions:  
-- Description:		PAL/NTSC-FBAS-generator 32/16MHz version 
--
-- Revision:		0.25
-- License:		GPL
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity standalone is
    
port (
-------------------------------------------------------------------------------
--- io
-------------------------------------------------------------------------------
	sysclk:		in std_logic;			---in clock 16MHz
	cclock_i:	in std_logic;			
	cclock_o:	inout std_logic;
	rgb:		in std_logic_vector(2 downto 0);
	video:		inout std_logic_vector(4 downto 0);
	cgsel:		in std_logic;
	hsync,vsync:	in std_logic);
	
end entity standalone;

architecture main of standalone is

-------------------------------------------------------------------------------
--- the encoder component
-------------------------------------------------------------------------------
component fbas_encoder is
    port ( enclock :      in std_logic;                       -- system clock
           hsync   :      in std_logic;                       -- rgb value
           vsync   :      in std_logic;                       -- horizontal sync
           rgb     :      in std_logic_vector(2 downto 0);    -- carrier
           cgsel   :      in std_logic;                       -- color/grey
           pnmode  :      in std_logic;                       -- mode switch
           vid     :      inout std_logic_vector(4 downto 0));  -- video output
end component fbas_encoder;

begin
-------------------------------------------------------------------------------
--- clock divider	
-------------------------------------------------------------------------------
    process (cclock_i) is
    begin
	if (rising_edge(cclock_i)) then
	    cclock_o <= not(cclock_o);
	end if;
    end process;

-------------------------------------------------------------------------------
--- use the encoder
-------------------------------------------------------------------------------
    I1: fbas_encoder port map(rgb=>rgb,enclock=>sysclk,hsync=>hsync,vsync=>vsync,cgsel=>cgsel,pnmode=>'0',vid=>video);

-------------------------------------------------------------------------------
--- minimal configuration
-------------------------------------------------------------------------------
end architecture main;

configuration main of standalone is
    for main
    end for;
end configuration main;
